#include "Mydefs.h"
#include <stdio.h>
#include <unistd.h>
#include "various_functions.h"
#include <string.h>
#include "mem_wrappers.h"
#include "msg_queries.h"
#include <fcntl.h>
#include "print_messages.h"


int get_reply_headers(const char *parent) {	// This is recursive
	char *pro_buf;
	char *cur_reply;
	int have_reply=0;

	if((cur_reply=get_field(parent, FIRST_REPLY_FIELD))==NULL) {
		return(-1);
	}
	if(! field_is_null(cur_reply, SIZE_OF_MSG_NO)){
		printf("<UL>");
		have_reply=1;
	}
	while(! field_is_null(cur_reply, SIZE_OF_MSG_NO)) {
		if(! strncmp(get_field(cur_reply, PARENT_FIELD), parent, SIZE_OF_MSG_NO)) {
			printf("<LI>");
			print_reply_header(parent, cur_reply);
			if(get_reply_headers(cur_reply)<0) {
				return(-1);
			}
		}
		pro_buf=cur_reply;
		if((cur_reply=get_field(pro_buf, NEXT_FIELD))==NULL) {
			return(-1);
		}
		free(pro_buf);
	}
	if (have_reply) { printf("</UL>"); }
	return(1);
}

get_message_class_with_target(const char *first_message, const char *target) {
	char *cur_msg;
	char *temp;

	cur_msg=Strdup(first_message);

	while(! field_is_null(cur_msg, SIZE_OF_MSG_NO)) {
		if(! strncmp(cur_msg, target, SIZE_OF_MSG_NO)) {
			print_msg(cur_msg, TARGETED);
		}
		else {
			print_msg(cur_msg, NON_TARGETED);
		}
		if(!field_is_null(get_field(cur_msg, FIRST_REPLY_FIELD), SIZE_OF_MSG_NO)) {
			open_body_shell();
			if(get_reply_headers(cur_msg)<0) {
				return(-1);
			}
			close_shell();
		}
		temp=cur_msg;
		if((cur_msg=get_field(cur_msg, NEXT_FIELD))==NULL) {
			return(-1);
		}
		free(temp);
	}
	return(1);
}


int get_cur_messages(const char *month, const char *target) {
	char *cur_msg;		// Small leak...
	int fd;

	if ((fd=open(get_filename(month), O_RDONLY)) <0) {
		return(-1);
	}
	if((cur_msg=read_first_of_main(fd))==NULL) {
		close(fd);
		return(-1);
	}
	close(fd);
	if (! target) {
		target=make_null_msg_no(SIZE_OF_MSG_NO+1);
	}
	return (get_message_class_with_target(cur_msg, target));
}


