#include "Mydefs.h"
#include "msg_queries.h"
#include "msg_formating.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "msg_formating.h"
#include <string.h>
#include "various_functions.h"
#include "errors.h"
#include "msg_queries.h"

int new_msg(char *FromWhom, char *Subject, char *Text){//Memory leaks everywhere
	char *msg_no;
	char *tmp_msg_no;
	int fd;

	if((msg_no=new_msg_no())==NULL) {
		fatal_error("Try later");
	}
	if (write_msg(msg_no, format_new_msg(FromWhom, Subject, Text))<0) {
		fatal_error("Server error. Contact the system administrator");
	}
	if ((fd=open(get_filename(msg_no), O_RDWR)) <0) {
		return(-1);
	}
	if((tmp_msg_no=read_first_of_main(fd))==NULL) {
		close(fd);
		return(-1);
	}
	if(put_first_of_main(fd, msg_no) <0) {
		close(fd);
		return(-1);
	}
	close(fd);
	if (update_field(msg_no, NEXT_FIELD, tmp_msg_no) <0) {
		return(-1);
	}
}

// Monstruous memory leak;
int new_reply(char *parent, char *FromWhom, char *Subject, char *Text) {
	int fd;
	char *msg_no;
	char *tmp_msg_no;
	char *last_reply;

	if((msg_no=new_msg_no())==NULL) {
		fatal_error("Try later");
	}
	if (write_msg(msg_no, format_new_msg(FromWhom, Subject, Text))<0) {
		fatal_error("Server error. Contact the system administrator");
	}
	if(update_field(msg_no, PARENT_FIELD, parent)<0) {
		return(-1);
	}
	if(strcmp(get_filename(msg_no), get_filename(parent))) { /*Diff month*/
		if ((fd=open(get_filename(msg_no), O_RDWR)) <0) {
			return(-1);
		}
		if((tmp_msg_no=read_first_of_stray(fd))==NULL) {
			close(fd);
			return(-1);
		}
		if(put_first_of_stray(fd, msg_no) <0) {
			close(fd);
			return(-1);
		}
		close(fd);
		if(update_field(msg_no, NEXT_FIELD, tmp_msg_no)<0) {
			return(-1);
		}
//		free(tmp_msg_no);
		if((tmp_msg_no=get_field(parent, FIRST_REPLY_FIELD))==NULL) {
			return(-1);
		}
		if (! field_is_null(tmp_msg_no, SIZE_OF_MSG_NO)) { /*Not 1st*/
			if ((last_reply=get_last_reply(parent))==NULL) {
				return(-1);
			}
			if (update_field(last_reply, NEXT_FIELD, msg_no)<0) {
				return(-1);
			}
//			free(last_reply);
		}
		else { /* 1st reply */
			if(update_field(parent, FIRST_REPLY_FIELD, msg_no)<0) {
				return(-1);
			}
		}
	}
	else {			/* Same month */
		if((last_reply=get_field(parent, FIRST_REPLY_FIELD))==NULL) {
			return(-1);
		}
		if(update_field(parent, FIRST_REPLY_FIELD, msg_no)<0) {
			return(-1);
		}

		if(update_field(msg_no, NEXT_FIELD, last_reply)<0) {
			return(-1);
		}
//		free(last_reply);
	}
	return(1);
}


int post_message(char *FromWhom, char *Subject, char *Text, char *Status) {
	char pro_buf[SIZE_OF_MSG_NO+1];
	if (Status[0]==NEW_MESSAGE) {
		return(new_msg(FromWhom, Subject, Text));
	}
	if (Status[0]==NEW_REPLY) {
		strncpy(pro_buf, Status+1, SIZE_OF_MSG_NO);
		pro_buf[SIZE_OF_MSG_NO]='\0';
		if(!is_valid_msg_no(pro_buf)) {
			return(-1);
		}
		if (get_msg(pro_buf)==NULL) {
			return(-1);
		}
		return(new_reply(pro_buf, FromWhom, Subject, Text));
	}
	return(-1);
}

