#include "Mydefs.h"
#include <stdio.h>
#include "msg_queries.h"
#include <unistd.h>
#include "various_functions.h"
#include "html_parsing.h"
#include "mem_wrappers.h"

void print_html_footer() {
	printf("\n</TABLE></CENTER></BODY></HTML>\n");
}

void print_html_header() {
	printf("\n<HTML><BODY BGCOLOR=%s><CENTER><TABLE WIDTH=100\%>\n", BACKGROUND_COLOR);
}

void open_intro_shell() {
	printf("<TR><TD bgcolor=%s>", INTRO_COLOR);
}

void open_header_shell() {
	printf("<TR><TD bgcolor=%s>",HEADER_COLOR);
}

void open_body_shell() {
	printf("<TR><TD bgcolor=%s>", BODY_COLOR);
}

void close_shell() {
	printf("</TD></TR>");
}

void print_intro(char *month) {
	char *to, *pro;
	char *from, *year;
	int i;

	open_intro_shell();

	printf("Showing messages dated:");
	from=Strdup(month);
	for (i=0; i<HOW_MANY_MONTHS; i++) {
		to=get_printable_time(from);
		to[7]='\0';
		year=Strdup(from);
		year[4]='\0';
		printf(" %s %s |", to+3,year);
		free(year);
		free(to);
		pro=from;
		from=get_month_minus_one(from);
		free(pro);
	}
	printf("<BR> <A HREF=\"%s?%c%c\">Post New Message</A>", EXECUTABLE, POST_MESSAGE, NEW_MESSAGE);
	printf(" | <A HREF=\"%s?%c%c%d\">Past Messages</A>", EXECUTABLE, GET_MESSAGE, GET_CURRENT, get_month_diff(get_time(), month)+2);
	free(from);
	close_shell();
}

int print_msg(char *msg_no, int targeted) {
	char *message;
	char *FromWhom;
	char *Subject;
	char *Text;
	char *parent;
	int how_much_back;

	message=get_msg(msg_no);
	get_data_from_message(message, &FromWhom, &Subject, &Text);
	open_header_shell();
	if(targeted==TARGETED) {
		printf("<A NAME=\"%s\"> </A>", TARGET_TAG);
	}
	printf("<TABLE WIDTH=100\%><TD>");
	printf("\n<B>From:</B> %s<BR>\n<B>Subject:</B> %s<BR>\n", text_to_html(FromWhom),text_to_html(Subject));
	printf("</TD><TD><DIV ALIGN=RIGHT>");	// To get it stuck on the right;
	printf("%s</DIV></TD></TABLE>", get_printable_time(msg_no));
	close_shell();
	open_body_shell();
	printf("%s", text_to_html(Text));
	printf("\n<BR><BR><FONT SIZE=-1><a href=%s?%c%c%s>Reply to this message</a></FONT>", EXECUTABLE, POST_MESSAGE, NEW_REPLY, msg_no);
	if((parent=get_field(msg_no, PARENT_FIELD))==NULL) {
		return(-1);
	}
	if(! field_is_null(parent, SIZE_OF_MSG_NO)) {
		printf("\n<FONT SIZE=-1>   <a href=%s?%c%c%s#%s>Go to parent</a></FONT>", EXECUTABLE, GET_MESSAGE, GET_MESSAGE_CLASS, parent, TARGET_TAG);
	}
	else {
		how_much_back=get_month_diff(get_month(get_time()), msg_no);
		printf("\n<FONT SIZE=-1>   <a href=%s?%c%c%d>Past messages</a></FONT>", EXECUTABLE, GET_MESSAGE, GET_CURRENT, how_much_back+HOW_MANY_MONTHS);
	}
	close_shell();
	free(parent);
	free(message);
	free(FromWhom);
	free(Subject);
	free(Text);
	return(1);
}

int print_reply_header(const char *parent, char *msg_no) {
	char *FromWhom, *Subject, *Text;
	char *message;
	char get_message[3];

	get_message[0]='G';
	get_message[1]='M';
	get_message[2]='\0';

	if((message=get_msg(msg_no))==NULL) {
		return(-1);
	}
	if(get_data_from_message(message, &FromWhom, &Subject, &Text)<0) {
		return(-1);
	}
	printf("Reply: <A HREF=%s?%s%s#%s>%s</A> by <I>%s</I>\n on %s", EXECUTABLE, get_message, msg_no, TARGET_TAG, Subject, FromWhom, get_printable_time(msg_no));
	return(1);
}


