#include "Mydefs.h"
#include <stdlib.h>
#include <stdio.h>
#include "various_functions.h"
#include "msg_queries.h"
#include <unistd.h>
#include "print_messages.h"
#include "get_messages.h"

int get_message_class(char *query_string) {
	char *cur_field;

	if(! is_valid_msg_no(query_string)) {
		return(-1);
	}
	if((cur_field=get_field(query_string, PARENT_FIELD))==NULL) {
		return(-1);
	}
	if (! field_is_null(cur_field, SIZE_OF_MSG_NO)) { // Is reply
		if((cur_field=get_field(cur_field, FIRST_REPLY_FIELD))==NULL) {
			return(-1);
		}
		return(get_message_class_with_target(cur_field, query_string));
	}
	else {		// Is original
		free(cur_field);
		return(get_cur_messages(get_month(query_string),query_string));
	}
}

int get_current_class(char *query_string) {
	int how_many, i;
	char *month;
	char *temp;
	int ok=0;

	if(query_string[0]=='\0') {
		how_many=0;
	}
	else {
		if(sscanf(query_string, "%d", &how_many)<1) {
			return(-1);
		}
	}
	if(how_many > MAX_HISTORY || how_many<0) {
		return(-1);
	}
	month=get_month(get_time());
	if(how_many) {
		for(i=0; i<how_many; i++) {
			temp=month;
			month=get_month_minus_one(temp);
			free(temp);
		}
	}
	print_intro(month);
	for(i=0; i<HOW_MANY_MONTHS; i++) {
		if(get_cur_messages(month, NULL)>0) {
			ok=1;
		}
		temp=month;
		month=get_month_minus_one(temp);
		free(temp);
	}
	if(ok)
		return(1);
	return(-1);
}

int handle_get_request(char *query_string) {

	if (query_string[0]==GET_CURRENT) {
		return(get_current_class(query_string+1));
	}
	if (query_string[0]==GET_MESSAGE_CLASS) {
		return(get_message_class(query_string+1)); 
	}
	return(-1);
}

int handle_request(char *query_string) {
	int n;

	if (query_string[0]==POST_MESSAGE) {	//User posts message
		print_form(query_string+1);
		return(1);
	}
	if(query_string[0]==GET_MESSAGE) {	//User wants messages
		print_html_header();
		n=handle_get_request(query_string+1);
		print_html_footer();
		return(n);
	}
	return(-1);
}

