#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "Mydefs.h"
#include "mem_wrappers.h"
#include <time.h>
#include "msg_queries.h"
#include "print_messages.h"
#include "errors.h"

int is_valid_msg_no(char *msg_no);
void print_form(char *mode);
void print_reply_form(char *reply_to);
void print_new_form(void);
char *get_time();

int read_query_string(char *query_string) {
	int have_read;

	have_read=read(fileno(stdin), query_string, MAX_STRING);
	query_string[have_read]='\0';
	if (! have_read) {
		fatal_error("No Arguments");
	}
	return(have_read);
}

void print_form(char *mode) {

print_html_header();
  printf ("<FORM METHOD=POST ACTION=\"/cgi-bin/webnews\">
<FORM METHOD=POST ACTION=\"/cgi-bin/webnews\">
<BR>

<BR><B>From:</B><INPUT TYPE=text NAME=\"FromWhom\" VALUE=\"\" SIZE=\"20\">
<BR><B>Subject:</B><INPUT TYPE=text NAME=\"Subject\" VALUE=\"\" SIZE=\"20\">
<BR><TEXTAREA NAME=\"Text\" VALUE=\"\" ROWS=\"5\" COLS=\"40\"></TEXTAREA>
<INPUT TYPE=\"hidden\" NAME=\"Status\" VALUE=\"%s\">
<BR><INPUT TYPE=\"submit\" VALUE=\"Submit\"><FONT COLOR=\"#FF99FF\"></FONT>
</FORM>", mode);

}

int is_valid_msg_no(char *msg_no) {
	int i;

	if (strlen(msg_no)!=SIZE_OF_MSG_NO) {
		return(0);
	}
	for (i=0; i<SIZE_OF_MSG_NO; i++) {
		if (msg_no[i]<48 || msg_no[i]>57) {
			return(0);
		}
	}
	return(1);
}


char *get_month(const char *time) {
	char *return_val;
	return_val=(char *)Malloc(SIZE_OF_MONTH+1);
	strncpy(return_val, time, SIZE_OF_MONTH);
	return_val[SIZE_OF_MONTH]='\0';
	return(return_val);
}

int get_month_diff(char *big_month, char *small_month) {
	char months[3];
	char years[5];
	int b_y, s_y, b_m, s_m;

	strncpy(years, big_month, 4);
	years[4]='\0';
	strncpy(months, big_month+4,2);
	months[2]='\0';
	sscanf(years, "%d", &b_y);
	sscanf(months, "%d", &b_m);
	strncpy(years, small_month, 4);
	years[4]='\0';
	strncpy(months, small_month+4,2);
	months[2]='\0';
	sscanf(years, "%d", &s_y);
	sscanf(months, "%d", &s_m);
	return(12*(b_y-s_y)+ b_m-s_m);
}


char *get_month_minus_one(const char *month) {
	char *new_month;
	char pro_buf[5];
	int pro_num;
	int i;

	new_month=(char *)Malloc(SIZE_OF_MONTH+1);
	if(month[4]=='0' && month[5]=='1') {
		for (i=0; i<4; i++) {
			pro_buf[i]=month[i];
		}
		pro_buf[i]='\0';
		sscanf(pro_buf, "%d", &pro_num);
		sprintf(new_month, "%d", pro_num-1);
		new_month[4]='1';
		new_month[5]='2';
		new_month[6]='\0';
	}
	else {
		sscanf(month, "%d", &pro_num);
		sprintf(new_month, "%d", pro_num-1);
	}
	return (new_month);
}

char *get_time() {
	char *return_value;
	time_t cur_time;
	struct tm cur_tm;
	char pro_buf[3];
	int i;
	int iter[5], j;

	return_value=(char *)Malloc(SIZE_OF_MSG_NO+1);
	cur_time=time(NULL);
	cur_tm=*(localtime(&cur_time));		// man localtime
	i=0;
	sprintf(return_value, "%d", 1900+cur_tm.tm_year);
	i+=4;

	iter[0]=cur_tm.tm_mon+1;	// Einai 0-11 by default
	iter[1]=cur_tm.tm_mday;
	iter[2]=cur_tm.tm_hour;
	iter[3]=cur_tm.tm_min;
	iter[4]=cur_tm.tm_sec;

	for (j=0; j<5; j++) {
		sprintf(pro_buf, "%d", iter[j]);
		if (iter[j]<10) {
			return_value[i++]='0';
			return_value[i++]=pro_buf[0];
		}
		else {
			return_value[i++]=pro_buf[0];
			return_value[i++]=pro_buf[1];
		}
	}
	return_value[i]='\0';
	return (return_value);
}

int perfect_fit(char *buf, int number, int size) {
	int i, real_size;

	if(snprintf(buf, size, "%d", number)<0) {
		return(-1);
	}
	if ((real_size=strlen(buf)) < size) {
		for (i=0; i<real_size; i++) {
			buf[size-1-i]=buf[real_size-1-i];
		}
		for (i=0; i<size-real_size; i++) {
			buf[i]='0';
		}
	}
	return(1);
}

char *make_null_msg_no(int size) {
	char *return_value;
	int i;

	return_value=(char *)Malloc(size+1);
	for (i=0; i<size; i++) {
		return_value[i]='0';
	}
	return_value[i]='\0';
	return (return_value);
}

int field_is_null(const char *field, int size) {
	int ret_val;
	char *null_buf;
	null_buf=make_null_msg_no(size+1);
	ret_val=strncmp(null_buf, field, size);
//	free(null_buf);
	if(ret_val) {
		return(0);
	}
	return(1);
}

char *get_printable_time(char *msg_no) {
	char *ret_val;
	struct tm tmp_tm;
	time_t pro;
	char pro_buf[5];

	strncpy(pro_buf, msg_no, 4);
	pro_buf[4]='\0';
	sscanf(pro_buf, "%d", &tmp_tm.tm_year);
	tmp_tm.tm_year-=1900;
	msg_no+=4;

	strncpy(pro_buf, msg_no, 2);
	pro_buf[2]='\0';
	sscanf(pro_buf, "%d", &tmp_tm.tm_mon);
	tmp_tm.tm_mon--;
	msg_no+=2;

	if(*msg_no!='\0') {
		strncpy(pro_buf, msg_no, 2);
		pro_buf[2]='\0';
		sscanf(pro_buf, "%d", &tmp_tm.tm_mday);
		msg_no+=2;

		strncpy(pro_buf, msg_no, 2);
		pro_buf[2]='\0';
		sscanf(pro_buf, "%d", &tmp_tm.tm_hour);
		msg_no+=2;

		strncpy(pro_buf, msg_no, 2);
		pro_buf[2]='\0';
		sscanf(pro_buf, "%d", &tmp_tm.tm_min);
		msg_no+=2;

		strncpy(pro_buf, msg_no, 2);
		pro_buf[2]='\0';
		sscanf(pro_buf, "%d", &tmp_tm.tm_sec);
	}
	else {
		tmp_tm.tm_mday=1;
		tmp_tm.tm_hour=1;
		tmp_tm.tm_min=1;
		tmp_tm.tm_sec=1;
	}

	tmp_tm.tm_isdst=-1;
	pro=mktime(&tmp_tm);
	return (Strdup(ctime(&pro)));
}

char *get_printable_month(char *month) {
	char *ret_val;

	ret_val=(char *)Malloc(11);
	ret_val[0]='0';
	ret_val[1]='1';
	ret_val[2]='/';
	ret_val[3]=month[4];
	ret_val[4]=month[5];
	ret_val[5]='/';
	ret_val[6]=month[0];
	ret_val[7]=month[1];
	ret_val[8]=month[2];
	ret_val[9]=month[3];
	ret_val[10]='\0';
	return(ret_val);
}

